#version 120
#extension GL_ARB_texture_rectangle : enable

uniform sampler2DRect inputtex;
uniform sampler2DRect masktex;
uniform vec2 inputsize;
uniform vec2 masksize;

void main (void) {

    vec2 pos = gl_TexCoord[0].st;
    vec4 maskcol = texture2DRect( masktex, pos );

    vec4 color = vec4( 0,0,0,0 );
    if ( maskcol.r > 0.f ) {
        // simple, copy from top of input
        color = texture2DRect( inputtex, pos );
        color.a = maskcol.r;
    } else if ( maskcol.g > 0.f ) {
        // mmmhh, have to copy from bottom
        pos.y = inputsize.y - ( masksize.y - pos.y );
        color = texture2DRect( inputtex, pos );
        color.a = maskcol.g;
    } 
    

    gl_FragColor = color;

}
